disp('Summation of divergent series')

clear; clg; hold off
% Quadrature formula: trapezoidal rule.  This integrand drops
% off so fast that -2.8<=t<=2.8 is ample.
function [z,dz]=points(h)
n=round(2.8/h); t=h*(-n:n);
% x=1-0.5*cosh(sinh(t)); y=-t; dx=-0.5*sinh(sinh(t)).*cosh(t); dy=-1;
x=1-0.5*cosh(t); y=-t; dx=-0.5*sinh(t); dy=-1;
z=x+i*y; dz=i*h/2*(dx+i*dy).*csc(pi*z);
endfunction

u=[]; N=[]; [z,dz]=points(1/32); n=(length(z)-1)/2;
for s=[16 8 4 2 1], 
  j=find(rem(-n:n,s)==0); 
  N=[N;length(j)]; u=[u;s*sum(dz(j).*(2*z(j)).^(2*z(j)-1))];
%  For a plot of terms in sum, uncomment next line if running interactively.
%  if s==1, hold off; semilogy(abs(dz(j).*(2*z(j)).^(2*z(j)-1))); pause; end
  endfor

j=1:2:length(z); hold off; plot(z(j)); hold on; plot(z(j),'*');
gset nokey
print('divseries.ps')

format long
u, N
