disp('Problem 1, Romberg integration on subintervals and extrapolate')

format long
global count

function y = p1func (x)
  global count
  count=count+length(x);
  y = cos (log (x) ./ x) ./ x;
endfunction
  
function [y,s]=repeat_aitken(s)
for n=1:2:length(s)-1, [y,s]=aitken(s,n); end
endfunction

% We'll integrate between the zeros of the integrand and sum the series.

function x=p1zeros(n)
x=exp(-lambertw((0.5:n)*pi));
endfunction

n=17; a=[1,p1zeros(n)];
clear s
count=0;
for i=1:n,
  s(i)=romberg('p1func',a(i+1),a(i),[eps,0]);
  end
count

% Levin's T transformation is ideal for alternating series.
disp('Romberg+repeated Aitken, using zeros');
szeros=s;
[sumzeros,termzeros]=repeat_aitken(s);

% One can also use the extrema of the cos factor in the integrand

function x=p1extrema(n)
x=exp(-lambertw((0:n)*pi));
endfunction

n=17; a=[p1extrema(n)];
clear s
count=0;
for i=1:n,
  s(i)=romberg('p1func',a(i+1),a(i),[eps,0]);
  end
count

disp('Romberg+repeated Aitken, using extrema of cos factor');
sextrema=s;
[sumextrema,termextrema]=repeat_aitken(s);

disp('series');
    disp(sprintf('%24.16f & %24.16f \\\\ \n',[szeros sextrema]'));
disp('accelerated'); 
  disp(sprintf('%24.16f & %24.16f \\\\ \n',[termzeros termextrema]'));
summed=[sumzeros sumextrema]



